function reExecMapSystem()
{
	discoverFile("Add-ons/Client_MapSystem.zip");
	exec("Add-ons/Client_MapSystem/client.cs");
}

$MapSystem_override_master = 0;
$MapSystem_override_submap = 0;

$MapSystem_overridemapstr = "default";
$MapSystem_overridesubmapstr = "master";

$MapSystem_deathCount = 0;

package MapSystemPkg
{
	function handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime)
	{
		MapSystem_handleDeath($MapSystem_last_good_position);
		return Parent::handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime);
	}

	function GameConnection::onConnectionAccepted(%this)
	{
		$MapSystem_currentmapstr = "default";
		$MapSystem_currentsubmapstr = "default";

		return Parent::onConnectionAccepted(%this);
	}
};
deactivatePackage(MapSystemPkg);
activatePackage(MapSystemPkg);


$MapSystem_MapCount = mFloatLength($MapSystem_MapCount, 0);

exec("./client.gui");

if($MapSystem_mapped != 1)
{
	$remapDivision[$remapCount] = "Map System";

	$remapName[$remapCount] = "Show map and settings";
	$remapCmd[$remapCount] = "MapSystem_showall";
	$remapCount++;

	$MapSystem_mapped = 1;
}


$MapSystem_last_press_time = 0;
$MapSystem_doubletap_time = 500;
$MapSystem_ignore_depress = 0;

function MapSystem_speed_label_change(%n)
{
	cancel($MapSystem_speed_label_schedule);

	if(%n == 0)
	{
		MapSystem_pos_box_vel_label.setvalue("<color:0099FF> SPEED:");
		MapSystem_pos_box_vel_GND_label.setvalue("<color:33FF33> SPEED:");
		$MapSystem_speed_label_schedule = schedule(2000, 0, MapSystem_speed_label_change, 1);
	}
	else
	{
		MapSystem_pos_box_vel_label.setvalue("<color:0099FF><font:Liberation Mono:12> (AIR)");
		MapSystem_pos_box_vel_GND_label.setvalue("<color:33FF33><font:Liberation Mono:12> (GROUND)");
		$MapSystem_speed_label_schedule = schedule(2000, 0, MapSystem_speed_label_change, 0);
	}
}


function MapSystem_showall(%pressed)
{
	if(%pressed)
	{
		//A press while the full map is open doesn't mean anything
		//This allows a quick switch to the quickmap from the full map without
		//considering it another double tap to open the full map again
		if($MapSystem_showingall == 1)
			return;

		MapSystem_speed_label_change(0);

		cancel($MapSystem_blink_schedule);
		%stime = getSimTime();


		//double tap registered
		if((%stime - $MapSystem_last_press_time) <= $MapSystem_doubletap_time)
		{
			$MapSystem_showingall = 1;

			MapSystem_reposition_window();
			MapSystem_setupMap();
			MapSystem_update_loc();
		
			//move map area from mock to standard
			if(MapSystemMockGUISubcontainer.isMember(MapSystemMapArea))
			{
				MapSystemMockGUISubcontainer.remove(MapSystemMapArea);
				MapSystemMockGUISubcontainer.remove(MapSystemMapAreaAbove);
				MapSystemGUISubcontainer.add(MapSystemMapArea);
				MapSystemGUISubcontainer.add(MapSystemMapAreaAbove);
			}

			MapSystemMockGUISubcontainer.setVisible(0);
			Canvas.pushDialog(MapSystemGUI);

			$MapSystem_ignore_depress = 1;
		}

		//only pop up quickmap if large map isnt already showing
		else if($MapSystem_showingall != 1)
		{
			//move map area from standard to mock
			if(MapSystemGUISubcontainer.isMember(MapSystemMapArea))
			{
				MapSystemGUISubcontainer.remove(MapSystemMapArea);
				MapSystemGUISubcontainer.remove(MapSystemMapAreaAbove);
				MapSystemMockGUISubcontainer.add(MapSystemMapArea);
				MapSystemMockGUISubcontainer.add(MapSystemMapAreaAbove);
			}


			//crashing fix when the mock subcontainer is added to the PlayGUI
			//before the first spawn

			//addition delayed until map is first opened which fixes it

			if(!PlayGUI.isMember(MapSystemMockGUISubcontainer))
				PlayGUI.add(MapSystemMockGUISubcontainer);



			MapSystem_reposition_window();
			MapSystem_setupMap();
			MapSystem_update_loc();

			MapSystemMockGUISubcontainer.setVisible(1);
		}

		$MapSystem_last_press_time = %stime;

		MapSystem_update_loc();
	}

	else
	{
		if($MapSystem_ignore_depress)
		{
			$MapSystem_ignore_depress = 0;
			return;
		}

		$MapSystem_ignore_depress = 0;
		$MapSystem_showingall = 0;
		Canvas.popDialog(MapSystemGUI);
		MapSystemMockGUISubcontainer.setVisible(0);
		cancel($MapSystem_blink_schedule);
		cancel($MapSystem_speed_label_schedule);
	}
}

function MapSystem_setupMap(%master)
{
	%c = $MapSystem_MapCount;
	%master = $MapSystem_currentmapstr;

	if($MapSystem_override_master)
		%master = MapSystemMasterDropdown.getValue();

	%overrideSubmapVal = MapSystemSubmapDropdown.getValue();

	for(%i = 0; %i < %c; %i++)
	{
		%o = $MapSystem_MapObj[%i];

		if(%o.master $= %master)
		{
			if($MapSystem_override_submap && %o.submap $= %overrideSubmapVal)
			{
				%foundObj = %o;
				break;
			}

			//if 'master' is found, keep searching
			//if something other than 'default' is found, break and use that obj

			if(%o.submap $= "master")
			{
				%foundObj = %o;

				//if a master is found and we only want masters, just quit
				//if looking for all maps, just try to keep searching for a submap

				if($MapSystem_guimap_showonlymasters)
					break;
			}

			else
			{
				%playerpos = $MapSystem_last_good_position;
				%playerposx = getWord(%playerpos, 0);
				%playerposy = getWord(%playerpos, 1);

				%map_x1 = getWord(%o.p1, 0);
				%map_y1 = getWord(%o.p1, 1);
				%map_x2 = getWord(%o.p2, 0);
				%map_y2 = getWord(%o.p2, 1);

				if(%playerposx < %map_x1 || %playerposy < %map_y1)
					continue;

				if(%playerposx > %map_x2 || %playerposy > %map_y2)
					continue;

				%foundObj = %o;
				break;
			}
		}
	}

	$MapSystem_currentmapobj = %foundObj;


	MapSystem_update_loc();

	MapSystemMap.bitmap = %foundObj.path;

	if($MapSystem_currentmapobj.hasLabelVers && $MapSystem_guimap_showlabels)
		MapSystemMap.bitmap = strreplace(%foundObj.path, ".png", "_labeled.png");

	MapSystemMap.setBitmap(MapSystemMap.bitmap);

	MapSystemMap.extent = "528 528";
	MapSystemMap.setVisible(1);

	%mmap_binding = movemap.getBinding("MapSystem_showall");
	%mmap_type = getField(%mmap_binding, 0);
	%mmap_key = getField(%mmap_binding, 1);

	%t0 = "Master map: <color:FFFFFF>"@ %foundObj.master @"<br>";
	%t1 = "<color:FF0000>Submap: <color:FFFFFF>"@ %foundObj.submap @"<br>";
	%t2 = "<font:arial:16><color:FF0000>Keybind: <color:FFFFFF><"@ %mmap_type @"> <color:FF0000>"@ %mmap_key @" <color:FFFF00>(double tap to show settings)";

	MapSystemMapAreaAboveText.setValue(%t0 @ %t1 @ %t2 @ %t3 @ %t4 @ %t5 @ %t6 @ %t7);


	MapSystemMasterDropdown.clear();
	%c = $MapSystem_MapCount;
	%dd = MapSystemMasterDropdown;

	for(%i = 0; %i < %c; %i++)
	{
		%o = $MapSystem_MapObj[%i];
		if(%foundMap[%o.master] != 1)
		{
			%foundMap[%o.master] = 1;
			%dd.add(%o.master, %dd.size());
		}
		
	}
	%dd.setValue($MapSystem_overridemapstr);



	MapSystemSubmapDropdown.clear();
	%c = $MapSystem_MapCount;
	%dd = MapSystemSubmapDropdown;

	for(%i = 0; %i < %c; %i++)
		if((%o = $MapSystem_MapObj[%i]).master $= %master)
			%dd.add(%o.submap, %dd.size());
	%dd.setValue($MapSystem_overridesubmapstr);
	MapSystem_repositionDeaths();
}



//	%type is 2D or 3D_isometric (2d maps define scale?, 3d ISO define...?)
//					(can also define minimap scale)

function MapSystem_registerMap(%master, %submap, %type, %imgext, %p1, %p2, %path, %hasLabelVers) //<--- more parameters describe map itself
{
	if(%type !$= "2D")
	{
		error("(MapSystem_registerMap) accepted types are: \"2D\"");
		return;
	}

	%found = 0;
	%foundObj = -1;
	%c = $MapSystem_MapCount;
	for(%i = 0; %i < %c; %i++)
	{
		%o = $MapSystem_MapObj[%i];
		if(%o.master $= %master && %o.submap $= %submap)
		{
			%found = 1;
			%foundObj = %o;
			break;
		}
	}

	if(!isObject(%foundObj))
	{
		%foundObj = new ScriptObject()
		{
			class = MS_Object;
		};

		$MapSystem_MapObj[$MapSystem_MapCount] = %foundObj;
		$MapSystem_MapCount++;
	}
	else
		%extra = " (overwritten)";

	%foundObj.master = %master;
	%foundObj.submap = %submap;
	%foundObj.type = %type;
	%foundObj.imgext = %imgext;
	%foundObj.p1 = %p1;
	%foundObj.p2 = %p2;
	%foundObj.path = %path;
	%foundObj.hasLabelVers = %hasLabelVers;

	echo("Added MapSystem map: "@ %master @" -> "@ %submap @" as map "@ %i @" as object "@ %foundObj @ %extra);
}

MapSystem_registerMap("default", "master",  "2D", "528 528", "-10000 -10000", "10000 10000", "./default_map/master.png", 1);
MapSystem_registerMap("default", "zoomed2k", "2D", "528 528",   "-2000 -2000", "2000 2000", "./default_map/master_zoomed_2k.png", 1);

MapSystem_registerMap("default_test", "master",  "2D", "528 528", "-10000 -10000", "10000 10000", "./default_map_test/master.png", 1);
MapSystem_registerMap("default_test", "zoomed2k", "2D", "528 528",   "-2000 -2000", "2000 2000", "./default_map_test/master_zoomed_2k.png", 1);


function MapSystem_reposition_window()
{
	%pg_ext = PlayGUI.extent;
	%pg_ext_x = getWord(%pg_ext, 0);
	%pg_ext_y = getWord(%pg_ext, 1);

	%img_ext = "800 600";
	%img_ext_x = getWord(%img_ext, 0);
	%img_ext_y = getWord(%img_ext, 1);

	%img_pos_x = mFloatLength((%pg_ext_x - %img_ext_x) / 2, 0);
	%img_pos_y = mFloatLength((%pg_ext_y - %img_ext_y) / 2, 0);

	MapSystemGUISubcontainer.extent = %img_ext;
	MapSystemGUISubcontainer.position = %img_pos_x SPC %img_pos_y;

	MapSystemMockGUISubcontainer.extent = %img_ext;
	MapSystemMockGUISubcontainer.position = %img_pos_x SPC %img_pos_y;
}

function MapSystem_dropdown_responder(%name)
{
	if(%name $= "")
		return;

	else if(%name $= "MapSystemMasterDropdown")
	{
		$MapSystem_overridemapstr = %name.getValue();
		$MapSystem_overridesubmapstr = "default";
		MapSystem_setupMap();

	}

	else if(%name $= "MapSystemSubmapDropdown")
	{
		$MapSystem_overridesubmapstr = %name.getValue();
		MapSystem_setupMap();
	}
}

function MapSystem_checkbox_clicked(%name)
{
	if(%name $= "")
		return;

	else if(%name $= "MapSystemMasterOverride")
	{
		%v = %name.getValue();

		MapSystemMasterDropdown.enabled = %v;
		$MapSystem_override_master =  %v;

		MapSystem_setupMap();
	}

	else if(%name $= "MapSystemSubmapOverride")
	{
		%v = %name.getValue();

		MapSystem_guimapscale_radioBtn_all.enabled = !%v;
		MapSystem_guimapscale_radioBtn_onlymasters.enabled = !%v;

		MapSystemSubmapDropdown.enabled = %v;
		$MapSystem_override_submap =  %v;

		MapSystem_setupMap();
	}
}


function MapSystem_radio_clicked(%name)
{
	if(%name $= "")
		return;

	else if(%name $= "MapSystem_guimapscale_radioBtn_all")
		$MapSystem_guimap_showonlymasters = 0;
	else if(%name $= "MapSystem_guimapscale_radioBtn_onlymasters")
		$MapSystem_guimap_showonlymasters = 1;

	else if(%name $= "MapSystem_guimaplabel_radioBtn_show")
		$MapSystem_guimap_showlabels = 1;
	else if(%name $= "MapSystem_guimaplabel_radioBtn_hide")
		$MapSystem_guimap_showlabels = 0;

	else if(%name $= "MapSystem_quickmapscale_radioBtn_all")
		$MapSystem_quickmap_showonlymasters = 0;
	else if(%name $= "MapSystem_quickmapscale_radioBtn_onlymasters")
		$MapSystem_quickmap_showonlymasters = 1;

	else if(%name $= "MapSystem_quickmaplabel_radioBtn_show")
		$MapSystem_quickmap_showlabels = 1;
	else if(%name $= "MapSystem_quickmaplabel_radioBtn_hide")
		$MapSystem_quickmap_showlabels = 0;

	MapSystem_setupMap();

	return %name;
}



//limited at 10 because deaths change color as they get older,
//and I can only have "\c$N" 10 colors
//not a good idea to change this
$MapSystem_max_deaths = 10;

function MapSystem_deleteAllDeaths()
{
	$MapSystem_deathCount = 0;
	for(%a = 0; %a < $MapSystem_max_deaths; %a++)
	{
		%d = $MapSystem_death[%a];
		if(isObject(%d))
			%d.delete();
	}
}

MapSystem_deleteAllDeaths();

if($MapSystem_max_deaths > 10)
	$MapSystem_max_deaths = 10;


function MapSystem_repositionDeaths()
{
	for(%a = 0; %a < $MapSystem_deathCount; %a++)
	{
		%d = $MapSystem_death[%a];
		if(!isObject(%d))
			continue;

		%dotPos = MapSystem_translatePosToImage($MapSystem_currentmapobj, %d.deathPos);
		%dotPosOffset = MapSystem_offsetDot(%dotPos);
		%d.position = %dotPosOffset;
	}
}

function MapSystem_handleDeath(%pos)
{
	if($MapSystem_deathCount == $MapSystem_max_deaths)
	{
		//delete dot associated with the oldest death
		$MapSystem_death[0].delete();

		//move all deaths down one position
		for(%a = 1; %a < $MapSystem_max_deaths; %a++)
			$MapSystem_death[%a - 1] = $MapSystem_death[%a];

		$MapSystem_deathCount--;
	}

	MapSystemMapArea.add($MapSystem_death[$MapSystem_deathCount] =
	new GuiTextCtrl()
	{
	   deathPos = %pos;
	   deathTime = getSimTime();

	   profile = "MapSystemDeathDotProfile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = "0 0";
	   extent = "12 72";
	   minExtent = "12 72";
	   visible = "1";
	   clipToParent = "1";
	   text = "";
	   maxLength = "255";
	});

	$MapSystem_deathCount++;
	for(%a = 0; %a < $MapSystem_deathCount; %a++)
	{
		%whichColor = $MapSystem_deathCount - %a - 1;
		eval("%text = \"\\c"@ (%whichColor) @".\";");
		$MapSystem_death[%a].setText(%text);
	}

	//keep the location dot on top, and the dir dot on top of that
	MapSystemMapArea.pushToBack(SurvivalMapLocationDot);
	MapSystemMapArea.pushToBack(SurvivalMapDirDot);

	for(%i = 0; %i < $MapSystem_dirDotCount; %i++)
		if(isObject(%d = $MapSystem_dirdot[%i]))
			MapSystemMapArea.pushToBack(%d);

	MapSystem_repositionDeaths();
}

function MapSystem_position_loop()
{
	%sc = serverConnection;

	if(!isObject(%sc))
	{
		//no longer or not connected to a server, so stop looking for a position
		$MapSystem_position_schedule = schedule(10000, 0, MapSystem_position_loop);
		if($MapSystem_deathCount > 0)
			MapSystem_deleteAllDeaths();
		return;
	}

	if(!isObject(%scgco = %sc.getControlObject()))
	{
		//loading but not yet spawned
		$MapSystem_position_schedule = schedule(5000, 0, MapSystem_position_loop);
		if($MapSystem_deathCount > 0)
			MapSystem_deleteAllDeaths();
		return;
	}

	if((%pos = %scgco.getPosition()) !$= "")
	{
		$MapSystem_last_good_position = %pos;
		$MapSystem_last_good_direction = %scgco.getForwardVector();
	}
	$MapSystem_position_schedule = schedule(5000, 0, MapSystem_position_loop);
}
cancel($MapSystem_position_schedule);
cancel($MapSystem_blink_schedule);
MapSystem_position_loop();


function MapSystem_translatePosToImage(%mapobj, %curpos)
{
	%point0 = %mapobj.p1; //southwest corner
	%point1 = %mapobj.p2; //northeast corner

	//where is the point inside the point0 and point1 boundary?
	%point_diff = vectorSub(%point1, %point0);
	%point_diff_x = getWord(%point_diff, 0);
	%point_diff_y = getWord(%point_diff, 1);

	//represent the 3d position as a fraction of 1 for each component
	%curpos_diff_from_point0 = vectorSub(%curpos, %point0);
	%points_diff_from_point0_x = getWord(%curpos_diff_from_point0, 0);
	%points_diff_from_point0_y = getWord(%curpos_diff_from_point0, 1);

	%points_diff = vectorSub(%point1, %point0);
	%points_diff_x = getWord(%points_diff, 0);
	%points_diff_y = getWord(%points_diff, 1);

	%curpos_as_fraction_x = %points_diff_from_point0_x / %points_diff_x;
	%curpos_as_fraction_y = %points_diff_from_point0_y / %points_diff_y;
	%curpos_as_fraction = %curpos_as_fraction_x SPC %curpos_as_fraction_y;



	//the extent may be backwards...
	%extent = %mapobj.imgext;
	%extent_x = getWord(%extent, 0);
	%extent_y = getWord(%extent, 1);

	%img_placement_x = %curpos_as_fraction_x * %extent_x;
	%img_placement_y = %extent_y - %curpos_as_fraction_y * %extent_y;

	return mFloatLength(%img_placement_x, 0) SPC mFloatLength(%img_placement_y, 0);
}

function MapSystem_offsetDot(%pos)
{
	return getWord(%pos, 0) - 7 SPC getWord(%pos, 1) - 53;
}

function MapSystem_getDotPos(%mapobj, %curpos)
{
	%point0 = %mapobj.p1; //northwest corner
	%point0_img = 0 SPC 0;

	%point1 = %mapobj.p2; //southeast corner
	%point1_img = %mapobj.imgext; //take into account the extent of the image

	%imgheight = getWord(%point1_img, 0);

	%point0_x = getWord(%point0, 0);
	%point0_y = getWord(%point0, 1);

	%point_diff = vectorSub(%point1, %point0);
	%point_diff_x = getWord(%point_diff, 0);
	%point_diff_y = getWord(%point_diff, 1);


	%pos_x = getWord(%curpos, 0);
	%pos_y = getWord(%curpos, 1);
	%pos_z = getWord(%curpos, 2);

	%x_diff = (%pos_x - %point0_x);
	%y_diff = (%pos_y - %point0_y);

	%z_diff = %pos_z - 8;

	%point0_img_x = getWord(%point0_img, 0);
	%point0_img_y = getWord(%point0_img, 1);

	%point1_img_x = getWord(%point1_img, 0);
	%point1_img_y = getWord(%point1_img, 1);

	%point_img_d_x = %point1_img_x - %point0_img_x;
	%point_img_d_y = %point1_img_y - %point0_img_y;

	%y_diff_scale = mFloatLength((%x_diff / %point_diff_x) * (%point_img_d_x) + %point0_img_x, 0);
	%x_diff_scale = mFloatLength((%y_diff / %point_diff_y) * (%point_img_d_y) + %point0_img_y, 0);

	//swap x and y when drawing
	return (%y_diff_scale - 7) SPC (%imgheight - (%x_diff_scale - 53));
}

function MapSystem_update_loc()
{
	cancel($MapSystem_blink_schedule);

	%sc = serverConnection;

	if(!isObject(%sc) || !isObject(%scgco = %sc.getControlObject()))
	{
		//no longer in-game
		MapSystemLocationDot.setVisible(0);
		MapSystemDirDot.setVisible(0);

		for(%a = 0; %a < $MapSystem_dirdotCount; %a++)
			if(isObject(%d = $MapSystem_dirdot[%a]))
				%d.setVisible(0);
		return;
	}

	//check if player has a valid position
	if((%pos = %scgco.getPosition()) !$= "")
	{
		$MapSystem_last_good_position = %pos;

		%pos_x = mFloatLength(getWord(%pos, 0), 1);
		%pos_y = mFloatLength(getWord(%pos, 1), 1);
		%pos_z = mFloatLength(getWord(%pos, 2), 1);

		if(%pos_x >= 0)
			%pos_x = " "@ %pos_x;

		if(%pos_y >= 0)
			%pos_y = " "@ %pos_y;

		if(%pos_z >= 0)
			%pos_z = " "@ %pos_z;

		MapSystem_pos_box_x.setvalue("<color:FFCC00><font:Liberation Mono:18><just:right>"@ %pos_x @" ");
		MapSystem_pos_box_y.setvalue("<color:FFCC00><font:Liberation Mono:18><just:right>"@ %pos_y @" ");
		MapSystem_pos_box_z.setvalue("<color:FFCC00><font:Liberation Mono:18><just:right>"@ %pos_z @" ");


		%vel_vector = %scgco.getVelocity();
		%vel = mFloatLength(vectorLen(%vel_vector), 1);
		MapSystem_pos_box_vel.setvalue("<color:00CCFF><font:Liberation Mono:18><just:right>"@ %vel @" ");

		%vel_GND = mFloatLength(vectorLen(getWords(%scgco.getVelocity(), 0, 1)), 1);
		MapSystem_pos_box_vel_GND.setvalue("<color:00CCFF><font:Liberation Mono:18><just:right>"@ %vel_GND @" ");


		//unit vector of the player's direction
		$MapSystem_last_good_direction = %forvector = %scgco.getForwardVector();

		MapSystemLocationDot.setText("\c2.");
		%dotPos = MapSystem_translatePosToImage($MapSystem_currentmapobj, %pos);
		%dotPosOffset = MapSystem_offsetDot(%dotPos);
		MapSystemLocationDot.position = %dotPosOffset;

		MapSystemLocationDot.setVisible(1);
		MapSystemLocationDot.schedule(400, setVisible, 0);





		//in a vehicle, the Z component has value other than 0.
		//take out Z component and renormalize vector
		%forvector_norm = VectorNormalize(getWord(%forvector, 1) SPC getWord(%forvector, 0));

		//center the small dir dot over the location dot
		%dirdot_x = getWord(%dotPosOffset, 0) + 3.5;
		%dirdot_y = getWord(%dotPosOffset, 1) + 26.75;

		//swap x and y to display on the image
		%dirdot_y += -getWord(%forvector_norm, 0) * 4;
		%dirdot_x += getWord(%forvector_norm, 1) * 4;

		MapSystemDirDot.position = mFloatLength(%dirdot_x, 0) SPC mFloatLength(%dirdot_y, 0);
		MapSystemDirDot.setVisible(1);
		MapSystemDirDot.schedule(400, setVisible, 0);


		for(%a = 0; %a < $MapSystem_dirdotCount; %a++)
		{
			if(isObject(%d = $MapSystem_dirdot[%a]))
			{
				%factor = (%a+1);
				%factorScalar = 50;

				if(%a > 1)
					%factor = mPow(%a + 1, 1.6);

				if(%a >= 12)
					%factor = mPow(%a + 1, (1.6 + (%a-12) * 0.0355));

				if(%a == 23)
					%d.setValue("\c3.");


				//try to fix this to use my functions instead of swapping y and x
				%vmult = vectorScale(%forvector_norm, (%factor) * %factorScalar);

				%vmult_x = getWord(%vmult, 0);
				%vmult_y = getWord(%vmult, 1);

				%vmult = %vmult_y SPC %vmult_x;

				%thisDirDotPos = MapSystem_translatePosToImage($MapSystem_currentmapobj, vectorAdd(%pos, %vmult));
				%dotPosOffset = MapSystem_offsetDot(%thisDirDotPos);

				%dirdot_x = getWord(%dotPosOffset, 0) + 3.5;
				%dirdot_y = getWord(%dotPosOffset, 1) + 26.75;

				%d.position = mFloatLength(%dirdot_x, 0) SPC mFloatLength(%dirdot_y, 0);

				%d.schedule(0   + ((%a+1) * 25), setVisible, 1);
				%d.schedule(250 + ((%a+1) * 25), setVisible, 0);
			}
		}

		MapSystemMap.pushToBack(MapSystemLocationDot);
		MapSystemMap.pushToBack(MapSystemDirDot);
	}

	else
	{
		//no valid position, so make dots disappear
		MapSystemLocationDot.setVisible(0);
		MapSystemDirDot.setVisible(0);
		return;
	}

	$MapSystem_blink_schedule = schedule(500, 0, MapSystem_update_loc);
}

function MapSystem_rotatePointXY(%pt, %ang)
{
	%pos_x = getWord(%pt, 0);
	%pos_y = getWord(%pt, 1);
	%pos_z = getWord(%pt, 2); //z remains the same

	%len = vectorLen(%pos_x SPC %pos_y);
	%angle_orig = mAtan(%pos_y, %pos_x);

	%angle = %angle_orig + mDegToRad(%ang);

	%pos_x_rot = mCos(%angle) * %len;
	%pos_y_rot = mSin(%angle) * %len;

	return %pos_x_rot SPC %pos_y_rot SPC %pos_z;
}

//defaults
MapSystem_radio_clicked(MapSystem_guimapscale_radioBtn_all).setValue(1);
MapSystem_radio_clicked(MapSystem_guimaplabel_radioBtn_show).setvalue(1);

MapSystem_radio_clicked(MapSystem_quickmapscale_radioBtn_all).setValue(1);
MapSystem_radio_clicked(MapSystem_quickmaplabel_radioBtn_show).setvalue(1);

